'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_DT.bas                                                      !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Datum und Zeitfunktion                                                !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !
'   !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'

$regfile = "m2561def.dat"                                   ' specify the used micro


 '///////////////// RTC Clock Timer 0 //////////////////////// do not delete!
 '4000000 / 256 =

'On Ovf0 Tim0_int                                            'Define the ISR handler
'Config Timer0 = Timer , Prescale = 256                      '
'Enable Timer0
'Enable Interrupts





'##########################################
'Definition von Funktionen und Prozeduren
'##########################################

Declare Sub Run_time()
Declare Sub Get_time()
Declare Sub Set_time()

Declare Sub Schalt_day_time(byval Anz As Byte)
Declare Sub Schalt_week_time(byval Anz As Byte)

'##########################################
'Definition von Globalen Variablen
'##########################################

Dim _msec As Byte
Dim _sec As Byte
Dim Sec_old As Byte
Dim Sec_alt As Byte

Dim _min As Byte
Dim _hour As Byte
Dim _day As Byte
Dim _month As Byte
Dim _year As Byte
Dim _imp As Byte

Dim Mday As Byte
Dim Week_day As Byte

Dim Ssec As String * 3
Dim Smin As String * 3
Dim Shour As String * 3
Dim Sday As String * 3
Dim Smonth As String * 3
Dim Syear As String * 3

Dim _date As String * 9
Dim _time As String * 9


'1-5 = Montag
'6-10 = Dienstag
'11-15 = Mittwoch
'16-20 = Donnerstag
'21-25 = Freitag
'26-30 = Samstag
'31-35 = Sonntag

Dim Schalt_std_on(10) As Byte
Dim Schalt_min_on(10) As Byte
Dim Schalt_std_off(10) As Byte
Dim Schalt_min_off(10) As Byte

'True or false
Dim Schaltuhr As Bit
Dim Korrtime As Bit


'####################################
'Systemfunktionen
'####################################


Goto Enddt


  'Time Interrupt
'==============
'Wird ca. 61 mal pro Sekunde aufgerufen
'Zur Auswertung muss Runtime im Anwenderprogramm
'aufgerufen werden

  'Tim0_int:

  'Incr _imp

  'Return



  Sub Run_time()

  If _imp => 61 Then

      _imp = 0

      'Korrektur pro Sek.
      '1 ms d.h. 86 sec = ca. 1,5 min langsamer pro Tag
      '2 ms d.h. 172 sec = ca. 3 min langsamer pro Tag
      'Waitms 2

      Incr _sec

  End If


  If _sec > 59 Then
     Incr _min
     _sec = 0
  End If

  If _min > 59 Then
     Incr _hour
     _min = 0
  End If

  If Week_day = 0 Or Week_day > 7 Then
     Week_day = 1
  End If

  If _hour > 23 Then
     Incr _day
     Incr Week_day
     _hour = 0
  End If


   If _day > 28 Then
     Select Case _month
        Case 1
           Mday = 31
        Case 2
           'Schaltjahr im Februar 2004,2208,2012 mit 29 Tagen
           Mday = _year And &H03
           If Mday = 0 Then
              Mday = 29
           Else
              Mday = 28
           End If
        Case 3
           Mday = 31
        Case 4
           Mday = 30
        Case 5
           Mday = 31
        Case 6
           Mday = 30
        Case 7
           Mday = 31
        Case 8
           Mday = 31
        Case 9
           Mday = 30
        Case 10
           Mday = 31
        Case 11
           Mday = 30
        Case 12
           Mday = 31
     End Select
     If _day > Mday Then
        _day = 1
        Incr _month
        If _month > 12 Then
           _month = 1
           Incr _year
        End If
     End If
  End If

  If _year > 99 Then
     _year = 0
  End If

  Get_time

  'Evtl. Korrektur fr Software Uhr
  If _time = "05:00:00" And Korrtime = 0 Then
     Korrtime = 1
     _time = "05:00:00"
     Set_time
  End If
  If _time = "06:00:00" And Korrtime = 1 Then
     Korrtime = 0
  End If


  End Sub





Sub Set_time()
     Dim S As String * 10

     S = Mid(_date , 1 , 2)
    _day = Val(s)

     S = Mid(_date , 4 , 2)
    _month = Val(s)

     S = Mid(_date , 7 , 2)
    _year = Val(s)

    S = Mid(_time , 1 , 2)
   _hour = Val(s)

    S = Mid(_time , 4 , 2)
   _min = Val(s)

    S = Mid(_time , 7 , 2)
   _sec = Val(s)

End Sub


Sub Get_time()

   If _day < 10 Then
        Sday = "0" + Str(_day)
      Else
        Sday = Str(_day)
      End If

      If _month < 10 Then
        Smonth = "0" + Str(_month)
      Else
        Smonth = Str(_month)
      End If

      If _year < 10 Then
        Syear = "0" + Str(_year)
      Else
        Syear = Str(_year)
      End If

      If _hour < 10 Then
        Shour = "0" + Str(_hour)
      Else
        Shour = Str(_hour)
      End If

       If _min < 10 Then
        Smin = "0" + Str(_min)
      Else
        Smin = Str(_min)
      End If

        If _sec < 10 Then
        Ssec = "0" + Str(_sec)
      Else
        Ssec = Str(_sec)
      End If


      _date = Sday + "." + Smonth + "." + Syear
      _time = Shour + ":" + Smin + ":" + Ssec


End Sub









Sub Schalt_day_time(anz As Byte)
Dim I As Byte
Dim _on As Bit

   _on = 0

   For I = 1 To Anz
     If _hour >= Schalt_std_on(1) Then
        If _min >= Schalt_std_on(1) Then
            _on = 1
        End If
     End If

     If _hour <= Schalt_std_off(1) And _on = 1 Then
        If _min <= Schalt_std_off(1) And _on = 1 Then
        Else
          _on = 0
        End If
     Else
       _on = 0
     End If

   Next I

   Schaltuhr = _on

End Sub

Sub Schalt_week_time(anz As Byte)
End Sub


'####################
'Modul Endekennung
'####################
Enddt: